"{ Package: 'cvut:stx/goodies/libsvn' }"

"{ NameSpace: SVN }"

Command subclass:#BranchCommand
	instanceVariableNames:'branch username password noAuthCache alreadyCleaned revision'
	classVariableNames:''
	poolDictionaries:''
	category:'SVN-Private-Commands'
!


!BranchCommand methodsFor:'accessing'!

branch: aBranch

    branch := aBranch.

    "Created: / 19-08-2009 / 09:55:16 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

revision
    ^ revision ? Revision head

    "Created: / 16-03-2008 / 10:00:05 / janfrog"
!

revision:aRevision
    revision := aRevision.

    "Created: / 16-03-2008 / 10:00:05 / janfrog"
!

url
    ^ branch url

    "Created: / 03-10-2008 / 16:27:17 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 19-08-2009 / 09:55:04 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!BranchCommand methodsFor:'executing'!

execute
    ^ [ super execute ] on:SVN::AuthorizationError
        do:[:ex | 
    |credentials dialog|

    credentials := Credentials new username:OperatingSystem getLoginName.
    credentials := (dialog := CredentialsDialog new)
                model:credentials;
                subTitle:self url;
                open.
    credentials 
        ifNil:[ ex pass ]
        ifNotNil:[
            username := credentials username.
            password := credentials password.
            noAuthCache := dialog savePassword not.
            self execute
        ]
]

    "Created: / 03-10-2008 / 17:26:24 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 08-11-2008 / 08:31:15 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!BranchCommand methodsFor:'executing - private'!

svnGlobalArgumentsOn: argStream

    super svnGlobalArgumentsOn: argStream.

    "/argStream nextPut:'--config-dir'; nextPut:'/tmp/.svn'; nextPut:'--no-auth-cache'.

    username ifNotNil:
        [argStream 
            nextPut: '--username';
            nextPut: username].
    password ifNotNil:
        [argStream 
            nextPut: '--password';
            nextPut: password].
    noAuthCache == true ifTrue:
        [argStream
            nextPutAll:'--no-auth-cache']

    "Created: / 03-10-2008 / 17:31:04 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!BranchCommand methodsFor:'initialization'!

initialize

    super initialize.
    alreadyCleaned := false

    "Created: / 08-11-2008 / 08:40:09 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!BranchCommand class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN
    ^'Id: SVN__BranchCommand.st 110 2009-08-19 13:21:10Z vranyj1 '
! !
