"{ Package: 'cvut:stx/goodies/libsvn' }"

"{ NameSpace: SVN }"

BranchCommand subclass:#UpdateLikeCommand
	instanceVariableNames:'workingCopy'
	classVariableNames:''
	poolDictionaries:''
	category:'SVN-Private-Commands'
!


!UpdateLikeCommand methodsFor:'accessing'!

workingCopy
    ^ workingCopy

    "Created: / 19-03-2008 / 12:44:24 / janfrog"
!

workingCopy:aSVNWorkingCopy

    self assert: (aSVNWorkingCopy isKindOf: SVN::WorkingCopy).
    
    workingCopy := aSVNWorkingCopy.
    branch := aSVNWorkingCopy branch.

    "Created: / 19-03-2008 / 12:44:24 / janfrog"
    "Modified: / 19-08-2009 / 12:22:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateLikeCommand methodsFor:'executing'!

execute
    ^[super execute] on:SVN::WorkingCopyLockedError do:
        [:ex | 
        alreadyCleaned 
            ifTrue:
                [ex pass]
            ifFalse:
                [self svnCleanup.
                alreadyCleaned := true.
                self execute]]

    "Created: / 08-11-2008 / 08:39:02 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!UpdateLikeCommand methodsFor:'executing - private'!

svnCleanup

    ^CleanupCommand new
        workingCopy: workingCopy;
        execute.

    "Created: / 08-11-2008 / 08:39:15 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

svnCmdArgumentsOn:arg 
    "raise an error: must be redefined in concrete subclass(es)"

    arg
        nextPut: '-r'; nextPut: self revision printString

    "Created: / 16-03-2008 / 10:00:34 / janfrog"
!

svnCmdWorkdir

    ^workingCopy path pathName

    "Created: / 19-03-2008 / 12:43:21 / janfrog"
    "Modified: / 19-08-2009 / 12:47:54 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

svnProcessCommandOutput: arg1 err: arg2 
    "Superclass says that I am responsible to implement this method"
    
    ^ arg1 contents asStringCollection asArray allButLast 
        collect: [:line | (WCActionNotification readFromString: line) wc: workingCopy; yourself ].

    "Created: / 03-10-2008 / 16:31:45 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 18-08-2009 / 14:38:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 27-08-2009 / 09:51:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!UpdateLikeCommand class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN
    ^'Id: SVN__UpdateLikeCommand.st 113 2009-08-28 11:43:01Z vranyj1 '
! !
